<template>
  <div v-if="props.resource" class="SimpleCreate">
    <PButton v-if="valid" class="p-button p-button-text" @click="create">
      <span
        >{{ t(`resource.${props.resourceType}.create`) }} "<span>{{
          name
        }}</span
        >"</span
      >
    </PButton>
    <span v-if="!valid && name" class="p-error">{{
      t('resource.common.nameTooLong', name?.length)
    }}</span>
  </div>
</template>

<script lang="ts" setup>
import { Resource, ResourceClient } from '@/api'
import { useI18n } from 'vue-i18n'
import { computed } from 'vue'
import { useFormValidation } from '@/components/form'
import { AxiosError } from 'axios'

const { t } = useI18n()

const props = defineProps<{
  resourceType: string
  labelProperty: string
  client: ResourceClient<Resource>
  resource: Record<string, unknown>
}>()

const name = computed(() => props.resource?.[props.labelProperty] as string)

const emit = defineEmits<{
  (e: 'created', resource: Resource): void
}>()

const { errors, clearErrors, parseViolations } = useFormValidation()

/**
 * True if name is valid
 */
const valid = computed(() => name.value && name.value.length <= 255)

/**
 * Creates a new client with given name
 */
const create = async () => {
  if (name.value && props.client.create) {
    try {
      clearErrors()
      const newResource = await props.client.create({ ...props.resource })
      emit('created', newResource)
    } catch (e) {
      if ((e as AxiosError)?.response?.status === 422) {
        parseViolations((e as AxiosError)?.response?.data.violations)
        return
      }
    }
  }
}
</script>
